﻿using System;
using System.Windows;
using System.Diagnostics;
using System.Windows.Shapes;
using System.Windows.Input;

namespace EventExamples {

	public partial class AttachedEvents : System.Windows.Window {

		public AttachedEvents() {
			InitializeComponent();

			if (DateTime.Now.Hour > 12) {

				// Example 4-7. 명시적인 결합 이벤트 처리

				myEllipse.AddHandler(Mouse.PreviewMouseDownEvent,
					new MouseButtonEventHandler(PreviewMouseDownEllipse));
				myEllipse.AddHandler(Mouse.MouseDownEvent,
					new MouseButtonEventHandler(MouseDownEllipse));

				// End of Example 4-7.
			}
			else {
				// Example 4-8. 도우미 함수를 이용한 결합 이벤트 처리

				Mouse.AddPreviewMouseDownHandler(myEllipse, PreviewMouseDownEllipse);
				Mouse.AddMouseDownHandler(myEllipse, MouseDownEllipse);

				// End of Example 4-8.
			}

		}
		void PreviewMouseDownButton(object sender, RoutedEventArgs e) { Debug.WriteLine("PreviewMouseDownButton"); }

		void MouseDownButton(object sender, RoutedEventArgs e) { Debug.WriteLine("MouseDownButton"); }


		void PreviewMouseDownGrid(
		  object sender, RoutedEventArgs e) { Debug.WriteLine("PreviewMouseDownGrid"); }

		void MouseDownGrid(object sender, RoutedEventArgs e) { Debug.WriteLine("MouseDownGrid"); }


		void PreviewMouseDownCanvas(object sender, RoutedEventArgs e) { Debug.WriteLine("PreviewMouseDownCanvas"); }

		void MouseDownCanvas(object sender, RoutedEventArgs e) { Debug.WriteLine("MouseDownCanvas"); }


		void PreviewMouseDownEllipse(object sender, RoutedEventArgs e) { Debug.WriteLine("PreviewMouseDownEllipse"); }

		void MouseDownEllipse(object sender, RoutedEventArgs e) { Debug.WriteLine("MouseDownEllipse"); }

	}
}