using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


namespace TicTacToe {
  public partial class Window1 : System.Windows.Window {
    string currentPlayer;

    Button[] cells;

    public Window1() {
      InitializeComponent();

      this.cells = new Button[] { this.cell00, this.cell01, this.cell02, this.cell10, this.cell11, this.cell12, this.cell20, this.cell21, this.cell22 };
      foreach (Button cell in this.cells) {
        cell.Click += cell_Click;
      }

      NewGame();
    }

    string CurrentPlayer {
      get { return this.currentPlayer; }
      set {
        this.currentPlayer = value;
        this.statusTextBlock.Text = ": " + this.currentPlayer;
      }
    }

    void NewGame() {
      foreach (Button cell in this.cells) {
        cell.Content = null;
      }
      CurrentPlayer = "X";
    }

    void cell_Click(object sender, RoutedEventArgs e) {
      Button button = (Button)sender;

      if (button.Content != null) { return; }

      button.Content = CurrentPlayer;

      if (HasWon(this.currentPlayer)) {
        MessageBox.Show("Winner!", "Game Over");
        NewGame();
        return;
      }
      else if (TieGame()) {
        MessageBox.Show("No Winner!", "Game Over");
        NewGame();
        return;
      }

      if (CurrentPlayer == "X") {
        CurrentPlayer = "O";
      }
      else {
        CurrentPlayer = "X";
      }
    }

    bool HasWon(string player) {
      Button[,] possibleWins = {
      { this.cell00, this.cell01, this.cell02, },
      { this.cell10, this.cell11, this.cell12, },
      { this.cell20, this.cell21, this.cell22, },

      { this.cell00, this.cell10, this.cell20, },
      { this.cell01, this.cell11, this.cell21, },
      { this.cell02, this.cell12, this.cell22, },

      { this.cell00, this.cell11, this.cell22, },
      { this.cell02, this.cell11, this.cell20, },
    };

      for (int i = 0; i != possibleWins.GetLength(0); ++i) {
        bool hasWon = true;
        for (int j = 0; j != possibleWins.GetLength(1); ++j) {
          if (possibleWins[i, j].Content == null || (string)possibleWins[i, j].Content != player) {
            hasWon = false;
            break;
          }
        }
        if (hasWon) { return true; }
      }

      return false;
    }

    bool TieGame() {
      foreach (Button cell in this.cells) {
        if (cell.Content == null) {
          return false;
        }
      }
      return true;
    }
  }
}
